"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Eurecia = void 0;
var axios_1 = __importDefault(require("axios"));
var Eurecia = /** @class */ (function () {
    function Eurecia() {
        this.BASE_URL = 'https://api.eurecia.com/eurecia/rest';
        this.instance = null;
    }
    Eurecia.prototype.authenticate = function (token) {
        return __awaiter(this, void 0, void 0, function () {
            var response, error_1;
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _d.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, (0, axios_1.default)({
                                method: 'get',
                                url: 'https://api.eurecia.com/eurecia/rest/v1/Auth',
                                headers: {
                                    Accept: 'application/json',
                                    authToken: token,
                                },
                            })];
                    case 1:
                        response = _d.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _d.sent();
                        throw new Error('Invalid token (#1)');
                    case 3:
                        if ((response === null || response === void 0 ? void 0 : response.status) !== 200) {
                            throw new Error('Invalid token (#2)');
                        }
                        if (((_c = (_b = (_a = response.data.eureciaResponse) === null || _a === void 0 ? void 0 : _a.temporaryToken) === null || _b === void 0 ? void 0 : _b.token) === null || _c === void 0 ? void 0 : _c.$) !== undefined) {
                            this.instance = axios_1.default.create({
                                baseURL: this.BASE_URL,
                                headers: {
                                    Accept: 'application/json',
                                    token: response.data.eureciaResponse.temporaryToken.token.$,
                                },
                            });
                        }
                        else
                            throw new Error('Invalid token (#3)');
                        return [2 /*return*/];
                }
            });
        });
    };
    Eurecia.prototype.query = function (method_1, endpoint_1) {
        return __awaiter(this, arguments, void 0, function (method, endpoint, data) {
            var response;
            if (data === void 0) { data = null; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.instance({
                            method: method,
                            url: endpoint,
                            data: data,
                        })];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response.data];
                }
            });
        });
    };
    Eurecia.prototype.getCompanies = function (page) {
        if (page === void 0) { page = 0; }
        var response = this.query('get', "/v4/companies?page=".concat(page));
        return response;
    };
    Eurecia.prototype.getAllCompanies = function () {
        return __awaiter(this, void 0, void 0, function () {
            var companies, page, promises, firstPage, pages, responses;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        companies = [];
                        page = 0;
                        promises = [];
                        return [4 /*yield*/, this.getCompanies(page)];
                    case 1:
                        firstPage = _a.sent();
                        pages = firstPage.totalPages;
                        page += 1;
                        while (page < pages) {
                            promises.push(this.getCompanies(page));
                            page += 1;
                        }
                        companies.push.apply(companies, firstPage.content);
                        return [4 /*yield*/, Promise.all(promises)];
                    case 2:
                        responses = _a.sent();
                        responses.forEach(function (res) {
                            res.content.forEach(function (company) {
                                companies.push(company);
                            });
                        });
                        return [2 /*return*/, companies];
                }
            });
        });
    };
    Eurecia.prototype.getEmployees = function (page, active) {
        if (page === void 0) { page = 0; }
        if (active === void 0) { active = true; }
        var response = this.query('get', "/v4/users".concat(active === true ? '/active' : '', "?page=").concat(page));
        return response;
    };
    Eurecia.prototype.getAllEmployees = function () {
        return __awaiter(this, arguments, void 0, function (active) {
            var employees, page, promises, firstPage, pages, responses;
            if (active === void 0) { active = true; }
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        employees = [];
                        page = 0;
                        promises = [];
                        return [4 /*yield*/, this.getEmployees(page, active)];
                    case 1:
                        firstPage = _a.sent();
                        pages = firstPage.totalPages;
                        page += 1;
                        while (page < pages) {
                            promises.push(this.getEmployees(page, active));
                            page += 1;
                        }
                        employees.push.apply(employees, firstPage.content);
                        return [4 /*yield*/, Promise.all(promises)];
                    case 2:
                        responses = _a.sent();
                        responses.forEach(function (res) {
                            res.content.forEach(function (employee) {
                                employees.push(employee);
                            });
                        });
                        return [2 /*return*/, employees];
                }
            });
        });
    };
    Eurecia.prototype.getEmployeeById = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.query('get', "/v4/users/".concat(id))];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    Eurecia.prototype.getDepartments = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.query('get', "/v4/departments")];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    Eurecia.prototype.getStructures = function () {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.query('get', "/v4/structures")];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    // async getPayrollGrids(): Promise<any> {
    //   const response = await this.query<any>('get', `/v1/payrollGrids`);
    //   return response;
    // }
    Eurecia.prototype.getVacationAccumulationForUser = function (id) {
        return __awaiter(this, void 0, void 0, function () {
            var response;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.query('get', "/v1/VacationAccumulation?userId=".concat(id))];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    return Eurecia;
}());
exports.Eurecia = Eurecia;
//# sourceMappingURL=index.js.map