"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var assert = require('assert');
var axios_1 = __importDefault(require("axios"));
var nock = require('nock');
var index_1 = require("./index");
describe('Eurecia', function () {
    var baseUrl = 'https://api.eurecia.com';
    var eurecia;
    axios_1.default.defaults.adapter = 'http';
    before(function () {
        eurecia = new index_1.Eurecia();
    });
    after(function () { });
    beforeEach(function () { });
    afterEach(function () { });
    describe('authenticate', function () {
        it('should throw an error when axios throws', function () { return __awaiter(void 0, void 0, void 0, function () {
            var scope, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v1/Auth')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('authToken', 'invalid-token')
                            .reply(500, null);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, eurecia.authenticate('invalid-token')];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        assert.strictEqual(error_1.message, 'Invalid token (#1)');
                        scope.done();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should throw an error for a non 200 http code', function () { return __awaiter(void 0, void 0, void 0, function () {
            var scope, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v1/Auth')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('authToken', 'invalid-token')
                            .reply(204, null);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, eurecia.authenticate('invalid-token')];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_2 = _a.sent();
                        assert.strictEqual(error_2.message, 'Invalid token (#2)');
                        scope.done();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should throw an error for an invalid returned object', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, error_3;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            eureciaResponse: {
                                temporaryToken: {
                                    token: {},
                                },
                            },
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v1/Auth')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('authToken', 'valid-token')
                            .reply(200, response);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, eurecia.authenticate('valid-token')];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_3 = _a.sent();
                        assert.strictEqual(error_3.message, 'Invalid token (#3)');
                        scope.done();
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); });
        it('should set the instance with the correct token', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            eureciaResponse: {
                                temporaryToken: {
                                    token: {
                                        $: 'temporary-token',
                                    },
                                },
                            },
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v1/Auth')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('authToken', 'valid-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.authenticate('valid-token')];
                    case 1:
                        _a.sent();
                        assert.strictEqual(eurecia.instance.defaults.headers.token, 'temporary-token');
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getCompanies', function () {
        it('should return the companies', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, companies;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            content: [
                                {
                                    id: "Company 1",
                                    descr: "Company 1's name",
                                    dateCreate: 1684338245000
                                },
                                {
                                    id: "Company 2",
                                    descr: "Company 2's name",
                                    dateCreate: 1684330000000
                                }
                            ],
                            pageable: "INSTANCE",
                            totalElements: 2,
                            totalPages: 1,
                            last: true,
                            number: 0,
                            sort: {
                                empty: true,
                                sorted: false,
                                unsorted: true
                            },
                            size: 2,
                            numberOfElements: 2,
                            first: true,
                            empty: false
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v4/companies?page=0')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.getCompanies()];
                    case 1:
                        companies = _a.sent();
                        assert.deepStrictEqual(companies, response);
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getAllCompanies', function () {
        it('should return all the companies', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response1, response2, scope1, scope2, companies;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response1 = {
                            content: [
                                {
                                    id: "Company 1",
                                    descr: "Company 1's name",
                                    dateCreate: 1684338245000
                                },
                                {
                                    id: "Company 2",
                                    descr: "Company 2's name",
                                    dateCreate: 1684330000000
                                }
                            ],
                            pageable: "INSTANCE",
                            totalElements: 4,
                            totalPages: 2,
                            last: false,
                            number: 0,
                            sort: {
                                empty: true,
                                sorted: false,
                                unsorted: true
                            },
                            size: 4,
                            numberOfElements: 2,
                            first: true,
                            empty: false
                        };
                        response2 = {
                            content: [
                                {
                                    id: "Company 3",
                                    descr: "Company 3's name",
                                    dateCreate: 1684338245000
                                },
                                {
                                    id: "Company 4",
                                    descr: "Company 4's name",
                                    dateCreate: 1684330000000
                                }
                            ],
                            pageable: "INSTANCE",
                            totalElements: 4,
                            totalPages: 2,
                            last: true,
                            number: 0,
                            sort: {
                                empty: true,
                                sorted: false,
                                unsorted: true
                            },
                            size: 4,
                            numberOfElements: 2,
                            first: false,
                            empty: false
                        };
                        scope1 = nock(baseUrl)
                            .get('/eurecia/rest/v4/companies?page=0')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response1);
                        scope2 = nock(baseUrl)
                            .get('/eurecia/rest/v4/companies?page=1')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response2);
                        return [4 /*yield*/, eurecia.getAllCompanies()];
                    case 1:
                        companies = _a.sent();
                        assert.deepStrictEqual(companies, [
                            response1.content[0],
                            response1.content[1],
                            response2.content[0],
                            response2.content[1],
                        ]);
                        scope1.done();
                        scope2.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getEmployees', function () {
        it('should return the employees', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, employees;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            content: [
                                {
                                    id: "ID1",
                                    email: "user1@mail.com",
                                    firstName: "John",
                                    lastName: "Doe",
                                    jobTitle: "Manager",
                                    department: "dept1",
                                    structure: "struct1"
                                },
                                {
                                    id: "ID2",
                                    email: "user2@mail.com",
                                    firstName: "Jane",
                                    lastName: "Doe",
                                    jobTitle: "Employee",
                                    department: "dept2",
                                    structure: "struct1"
                                },
                            ],
                            pageable: {
                                sort: {
                                    empty: true,
                                    sorted: false,
                                    unsorted: true
                                },
                                offset: 0,
                                pageNumber: 0,
                                pageSize: 50,
                                paged: true,
                                unpaged: false
                            },
                            totalElements: 2,
                            totalPages: 1,
                            last: true,
                            number: 0,
                            sort: {
                                empty: true,
                                sorted: false,
                                unsorted: true
                            },
                            size: 2,
                            numberOfElements: 2,
                            first: true,
                            empty: false
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v4/users/active?page=0')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.getEmployees()];
                    case 1:
                        employees = _a.sent();
                        assert.deepStrictEqual(employees, response);
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return the employees', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, employees;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            content: [
                                {
                                    id: "ID1",
                                    email: "user1@mail.com",
                                    firstName: "John",
                                    lastName: "Doe",
                                    jobTitle: "Manager",
                                    department: "dept1",
                                    structure: "struct1"
                                },
                                {
                                    id: "ID2",
                                    email: "user2@mail.com",
                                    firstName: "Jane",
                                    lastName: "Doe",
                                    jobTitle: "Employee",
                                    department: "dept2",
                                    structure: "struct1"
                                },
                            ],
                            pageable: {
                                sort: {
                                    empty: true,
                                    sorted: false,
                                    unsorted: true
                                },
                                offset: 0,
                                pageNumber: 0,
                                pageSize: 50,
                                paged: true,
                                unpaged: false
                            },
                            totalElements: 2,
                            totalPages: 1,
                            last: true,
                            number: 0,
                            sort: {
                                empty: true,
                                sorted: false,
                                unsorted: true
                            },
                            size: 2,
                            numberOfElements: 2,
                            first: true,
                            empty: false
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v4/users?page=0')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.getEmployees(0, false)];
                    case 1:
                        employees = _a.sent();
                        assert.deepStrictEqual(employees, response);
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getAllEmployees', function () {
        it('should return all the employees', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response1, response2, scope1, scope2, employees;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response1 = {
                            content: [
                                {
                                    id: "ID1",
                                    email: "user1@mail.com",
                                    firstName: "John",
                                    lastName: "Doe",
                                    jobTitle: "Manager",
                                    department: "dept1",
                                    structure: "struct1"
                                },
                                {
                                    id: "ID2",
                                    email: "user2@mail.com",
                                    firstName: "Jane",
                                    lastName: "Doe",
                                    jobTitle: "Employee",
                                    department: "dept2",
                                    structure: "struct1"
                                },
                            ],
                            pageable: {
                                sort: {
                                    empty: true,
                                    sorted: false,
                                    unsorted: true
                                },
                                offset: 0,
                                pageNumber: 0,
                                pageSize: 2,
                                paged: true,
                                unpaged: false
                            },
                            totalElements: 4,
                            totalPages: 2,
                            last: true,
                            number: 0,
                            sort: {
                                empty: true,
                                sorted: false,
                                unsorted: true
                            },
                            size: 2,
                            numberOfElements: 2,
                            first: true,
                            empty: false
                        };
                        response2 = {
                            content: [
                                {
                                    id: "ID3",
                                    email: "user3@mail.com",
                                    firstName: "Bob",
                                    lastName: "Johnson",
                                    jobTitle: "Developer",
                                    department: "dept1",
                                    structure: "struct2"
                                },
                                {
                                    id: "ID4",
                                    email: "user4@mail.com",
                                    firstName: "Alice",
                                    lastName: "Smith",
                                    jobTitle: "Sales",
                                    department: "dept2",
                                    structure: "struct2"
                                },
                            ],
                            pageable: {
                                sort: {
                                    empty: true,
                                    sorted: false,
                                    unsorted: true
                                },
                                offset: 2,
                                pageNumber: 1,
                                pageSize: 2,
                                paged: true,
                                unpaged: false
                            },
                            totalElements: 4,
                            totalPages: 2,
                            last: true,
                            number: 0,
                            sort: {
                                empty: true,
                                sorted: false,
                                unsorted: true
                            },
                            size: 2,
                            numberOfElements: 2,
                            first: true,
                            empty: false
                        };
                        scope1 = nock(baseUrl)
                            .get('/eurecia/rest/v4/users/active?page=0')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response1);
                        scope2 = nock(baseUrl)
                            .get('/eurecia/rest/v4/users/active?page=1')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response2);
                        return [4 /*yield*/, eurecia.getAllEmployees()];
                    case 1:
                        employees = _a.sent();
                        assert.deepStrictEqual(employees, [
                            response1.content[0],
                            response1.content[1],
                            response2.content[0],
                            response2.content[1],
                        ]);
                        scope1.done();
                        scope2.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getEmployeeById', function () {
        it('should return the employee', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, employee;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            id: "ID1",
                            email: "user1@mail.com",
                            firstName: "John",
                            lastName: "Doe",
                            jobTitle: "Manager",
                            department: "dept1",
                            structure: "struct1",
                            refNumber: "4242",
                            gender: "Mr",
                            phones: [],
                            socialSecurityNum: "1 23 45 67 123 456",
                            birthdayDate: 268000000000,
                            birthdayCity: "Paris",
                            addresses: {
                                main: {
                                    num: "",
                                    repetition: "EMPTY",
                                    roadName: "",
                                    address1: "1 rue de Paris",
                                    zipCode: "75001",
                                    city: "Paris",
                                    country: null,
                                    state: null
                                }
                            },
                            personalEmail: "personal@mail.com",
                            nationality: "FR",
                            entryDate: 1704668400000,
                            seniorityDate: 1704668400000,
                            seniorityShift: 0,
                            hiringDate: 1704668400000,
                            departureDate: 1722031200000,
                            workContract: "cdi",
                            professionalStatus: "manager",
                            qualification: "IT",
                            coefficient: "CA1",
                            workingTimeRate: 100.0,
                            workingTimeUnit: "day",
                            yearWorkingTime: 212,
                            activityType: "full",
                            legalHolidaysCalendar: "calendarId",
                            userSequences: [],
                            userManagers: [],
                            annualGrossSalary: 1337.0,
                            monthlyGrossSalary: 42.0,
                            mealVoucherIsActive: true,
                            benefits1: "abc.de",
                            benefits3: "Working staff",
                            benefits4: "lundi au vendredi",
                            benefits5: "5",
                            benefits6: "42.00",
                            userDirectManagers: [
                                "ID0"
                            ],
                            otherAccount: "",
                            otherAccount2: "",
                            additionalField1: "Field 1",
                            additionalField2: "Field 2",
                            flagHasACar: false,
                            flagHasAFuelCard: false,
                            transportMode: "",
                            vacationProfile: "vacationProfileId1",
                            reimbursementProfiles: [],
                            userProfile: "userProfileId1",
                            dateEndAccess: 32503676400000,
                            hasLogin: true,
                            flagOptOutEmail: false,
                            flagControlAccess: true,
                            idModules: "1[.]3[.]8[.]5",
                            feedDelegation: false,
                            ideaDelegation: false,
                            modelDelegation: false,
                            modelUsage: false,
                            hasOcr: true,
                            userCreate: "User create comment",
                            dateCreate: 1705502721000,
                            userUpdate: "User update comment",
                            dateUpdate: 1719582852000,
                            timezone: "Europe/Paris",
                            locale: "fr_FR",
                            displayImputationStructureInOneColumn: false,
                            sendICalVacationRequest: false,
                            sendICalVacationRequestOtherUser: false,
                            _embedded: {
                                userSequences: [],
                                userDirectManagers: [
                                    {
                                        id: "ID0",
                                        email: "big.boss@company.com",
                                        firstName: "Big",
                                        lastName: "Boss"
                                    }
                                ],
                                reimbursementProfiles: []
                            },
                            archived: false,
                            userIncludedInEVP: true,
                            admin: false
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v4/users/1')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.getEmployeeById(1)];
                    case 1:
                        employee = _a.sent();
                        assert.deepStrictEqual(employee, response);
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getDepartments', function () {
        it('should return the departments', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, departments;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            nodes: [
                                {
                                    organizationDto: {
                                        id: "ID1",
                                        name: "Department 1",
                                        type: "DEPARTMENT",
                                        typeLabel: "Département"
                                    },
                                    nodes: [],
                                },
                                {
                                    organizationDto: {
                                        id: "ID2",
                                        name: "Department 2",
                                        type: "DEPARTMENT",
                                        typeLabel: "Département"
                                    },
                                    nodes: [],
                                },
                            ],
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v4/departments')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.getDepartments()];
                    case 1:
                        departments = _a.sent();
                        assert.deepStrictEqual(departments, response);
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('getStructures', function () {
        it('should return the structures', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, structures;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            nodes: [
                                {
                                    organizationDto: {
                                        id: "ID1",
                                        name: "Structure 1",
                                        type: "STRUCTURE",
                                        typeLabel: "Structure"
                                    },
                                    nodes: [],
                                },
                                {
                                    organizationDto: {
                                        id: "ID2",
                                        name: "Structure 2",
                                        type: "STRUCTURE",
                                        typeLabel: "Structure"
                                    },
                                    nodes: [],
                                },
                            ],
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v4/structures')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.getStructures()];
                    case 1:
                        structures = _a.sent();
                        assert.deepStrictEqual(structures, response);
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    // describe('getPayrollGrids', () => {
    //   it('should return the payroll grids', async () => {
    //     const response = {
    //       data: ['payrollGrid1', 'payrollGrid2'],
    //     };
    //     const scope = nock(baseUrl)
    //       .get('/eurecia/rest/v4/payrollGrids')
    //       .matchHeader('Accept', 'application/json')
    //       .matchHeader('token', 'temporary-token')
    //       .reply(200, response);
    //     const payrollGrids = await eurecia.getPayrollGrids();
    //     assert.deepStrictEqual(payrollGrids, response);
    //     scope.done();
    //   });
    // });
    describe('getVacationAccumulationForUser', function () {
        it('should return the vacation accumulation for the user', function () { return __awaiter(void 0, void 0, void 0, function () {
            var response, scope, vacationAccumulation;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        response = {
                            eureciaResponse: {
                                totalElementsFound: {
                                    $: "5498"
                                },
                                startPadding: {
                                    $: "0"
                                },
                                endPadding: {
                                    $: "50"
                                },
                                list: {
                                    item: [
                                        {
                                            "@xmlns": {
                                                xsi: "http://www.w3.org/2001/XMLSchema-instance"
                                            },
                                            "@xsi:type": "vacationAccumulation",
                                            userCreate: {
                                                $: "cron@eurecia.com"
                                            },
                                            dateCreate: {
                                                $: "2024-06-01T03:04:23+02:00"
                                            },
                                            userUpdate: {
                                                $: "increaseAccumulations@eurecia.com"
                                            },
                                            dateUpdate: {
                                                $: "2024-07-01T03:11:21+02:00"
                                            },
                                            id: {
                                                idCompany: {
                                                    $: "COMPANYID1"
                                                },
                                                idUser: {
                                                    $: "USERID1"
                                                },
                                                idAccumulation: {
                                                    $: "ACCUMULATIONID1"
                                                },
                                                idVacationType: {
                                                    $: "VACATIONTYPEID1"
                                                },
                                                idCompanyType: {
                                                    $: "COMPANYTYPEID1"
                                                },
                                                yearOfEnd: {
                                                    $: "2025"
                                                }
                                            },
                                            nbCumulatedUnits: {
                                                $: "5.0"
                                            },
                                            nbUsedUnits: {
                                                $: "0.0"
                                            },
                                            nbLostUnits: {
                                                $: "0.0"
                                            },
                                            nbUnworkedDaysToTake: {
                                                $: "0.0"
                                            },
                                            accumulationTrackings: {
                                                accumulationTracking: [
                                                    {
                                                        idVacationAccumulationTracking: {
                                                            $: "VACATIONACCUMULATIONTRACKINGID1"
                                                        },
                                                        modificationDate: {
                                                            $: "2024-06-01T00:00:00+02:00"
                                                        },
                                                        description: {
                                                            $: "Init"
                                                        },
                                                        cumulatedDays: {
                                                            $: "0.0"
                                                        },
                                                        takenDays: {
                                                            $: "0.0"
                                                        },
                                                        unworkedDays: {
                                                            $: "0.0"
                                                        },
                                                        lostUnits: {
                                                            $: "0.0"
                                                        },
                                                        timeUnit: {
                                                            $: "days"
                                                        },
                                                        actor: {
                                                            $: "increaseAccumulations@eurecia.com"
                                                        }
                                                    },
                                                    {
                                                        idVacationAccumulationTracking: {
                                                            $: "VACATIONACCUMULATIONTRACKINGID2"
                                                        },
                                                        modificationDate: {
                                                            $: "2024-06-01T00:00:00+02:00"
                                                        },
                                                        description: {
                                                            $: "juin"
                                                        },
                                                        cumulatedDays: {
                                                            $: "2.5"
                                                        },
                                                        takenDays: {
                                                            $: "0.0"
                                                        },
                                                        unworkedDays: {
                                                            $: "0.0"
                                                        },
                                                        lostUnits: {
                                                            $: "0.0"
                                                        },
                                                        timeUnit: {
                                                            $: "days"
                                                        },
                                                        actor: {
                                                            $: "increaseAccumulations@eurecia.com"
                                                        }
                                                    },
                                                    {
                                                        idVacationAccumulationTracking: {
                                                            $: "VACATIONACCUMULATIONTRACKINGID3"
                                                        },
                                                        modificationDate: {
                                                            $: "2024-07-01T00:00:00+02:00"
                                                        },
                                                        description: {
                                                            $: "juillet"
                                                        },
                                                        cumulatedDays: {
                                                            $: "2.5"
                                                        },
                                                        takenDays: {
                                                            $: "0.0"
                                                        },
                                                        unworkedDays: {
                                                            $: "0.0"
                                                        },
                                                        lostUnits: {
                                                            $: "0.0"
                                                        },
                                                        timeUnit: {
                                                            $: "days"
                                                        },
                                                        actor: {
                                                            $: "increaseAccumulations@eurecia.com"
                                                        }
                                                    }
                                                ]
                                            }
                                        }
                                    ]
                                }
                            }
                        };
                        scope = nock(baseUrl)
                            .get('/eurecia/rest/v1/VacationAccumulation?userId=USERID1')
                            .matchHeader('Accept', 'application/json')
                            .matchHeader('token', 'temporary-token')
                            .reply(200, response);
                        return [4 /*yield*/, eurecia.getVacationAccumulationForUser('USERID1')];
                    case 1:
                        vacationAccumulation = _a.sent();
                        assert.deepStrictEqual(vacationAccumulation, response);
                        scope.done();
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=index.spec.js.map